import { QueryKey, UseInfiniteQueryOptions, UseInfiniteQueryResult } from "react-query";
import { Query, QuerySnapshot, DocumentData, FirestoreError } from "firebase/firestore";
import { GetSnapshotSource } from "./index";
export declare function useFirestoreInfiniteQuery<T = DocumentData, R = QuerySnapshot<T>>(key: QueryKey, initialQuery: Query<T>, getNextQuery: (snapshot: QuerySnapshot<T>) => Query<T> | undefined, options?: {
    source?: GetSnapshotSource;
}, useInfiniteQueryOptions?: Omit<UseInfiniteQueryOptions, "queryFn" | "getNextPageParam">): UseInfiniteQueryResult<R, FirestoreError>;
